/*
 Java Class Inspector
   Copyright (C) 1996 Clark VERBRUGGE.     Contact: clump@cs.mcgill.ca
   Copyright (C) 1996 McGill University. 
   Copyright (C) 1996 McCAT System Group.

   This program is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 1, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
   more details.

   You should have received a copy of the GNU General Public License along with
   this program; if not, write to the Free Software Foundation, Inc., 675
   Mass Ave, Cambridge, MA 02139, USA. */

import java.util.Enumeration;
import java.util.Vector;


// holds one basic block
public class BasicBlock {
	int size;                          // number of instructions in the bb
	Instruction head;                  // head & tail of list
	Instruction tail;
	Vector succ;                       // successors
	Vector pred;                       // predecessors
	//ReachingDefs rdefs;                // reaching defs for this basic block
	BasicBlock next;                   // actual syntactic order

	BasicBlock(Instruction insts) {
		head = insts;
		tail = head;
		size = 0;
		if (head!=null) {
			size++;
			while (tail.next!=null) {
				size++;
				tail = tail.next;
			}
		}
		succ = new Vector(2,10);
		pred = new Vector(2,3);
	}

	public int hashCode() {
		return (new Integer(head.label)).hashCode();
	}

	public boolean equals(BasicBlock b) {
		if (b.head.label == head.label) return true;
		return false;
	}
}
