/*
 Java Class Inspector
   Copyright (C) 1996 Clark VERBRUGGE.     Contact: clump@cs.mcgill.ca
   Copyright (C) 1996 McGill University. 
   Copyright (C) 1996 McCAT System Group.

   This program is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 1, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
   more details.

   You should have received a copy of the GNU General Public License along with
   this program; if not, write to the Free Software Foundation, Inc., 675
   Mass Ave, Cambridge, MA 02139, USA. */

import java.io.*;

class CONSTANT_Utf8_info extends cp_info {
	public byte bytes[];
	public int length() { return (((int)(bytes[0]))<<8 + bytes[1]); }
	public String convert() {
		try {
			ByteArrayInputStream bs = new ByteArrayInputStream(bytes);
			DataInputStream d = new DataInputStream(bs);
			return d.readUTF();
		} catch(IOException e) {
		}
		return "!!IOException!!";
	}
	public static byte[] toUtf8(String s) {
		try {
			ByteArrayOutputStream bs = new ByteArrayOutputStream(s.length());
			DataOutputStream d = new DataOutputStream(bs);
			d.writeUTF(s);
			return bs.toByteArray();
		} catch(IOException e) {
			System.out.println("Some sort of IO exception in toUtf8 with " + s);
		}
		return null;
	}
	public String toString(cp_info constant_pool[]) {
		return convert();
	}
	public String typeName() { return "utf8"; }
}
