/*
 Instructions.java Exploder
   Copyright (C) 1996 Clark VERBRUGGE.     Contact: clump@cs.mcgill.ca
   Copyright (C) 1996 McGill University. 
   Copyright (C) 1996 McCAT System Group.

   This program is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 1, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
   more details.

   You should have received a copy of the GNU General Public License along with
   this program; if not, write to the Free Software Foundation, Inc., 675
   Mass Ave, Cambridge, MA 02139, USA. */

import java.io.*;
import java.util.*;

public class Explode {

	String mainfn;

	public static boolean endOfClass(String s) {
		try {
			if (s.charAt(0)=='}') return true;
		} catch (StringIndexOutOfBoundsException e) {
		}
		return false;
	}

	public boolean writeClass(DataInputStream din,String fn,String firstline,
							  Vector imports) {
		FileOutputStream f;
		DataOutputStream d;
		String s;

		// first create the file
		try {
			f = new FileOutputStream(fn + ".java");
			d = new DataOutputStream(f);
			if (d==null) return false;

			// then write all import statements;
			for (Enumeration e = imports.elements();e.hasMoreElements();) {
				s = (String)(e.nextElement());
				d.writeBytes(s); d.write('\n');
			}
			// then write all lines, including firstline, until encountering a
			// lone '}'
			d.writeBytes(firstline); d.write('\n');
			while (din.available()>0) {
				s = din.readLine();
				d.writeBytes(s); d.write('\n');
				if (endOfClass(s)) { // done with class
					break;
				}
			} 
			d.close();
			f.close();
		} catch(FileNotFoundException e) {
			System.out.println("Can't find " + fn + ".java");
			return false;
		} catch(IOException e) {
			System.out.println("IOException with " + fn + ".java: " + e.getMessage());
			return false;
		}

		return true;
	}

	public void createSubfiles(DataInputStream din) {
		String fn,s;
		boolean pub=false,abs=false;
		Vector v = new Vector(10,10);
		
		// determine filename. Start parsing and save all import statements
		// in v
		try {
			int i,j,comment,c,len;
			while (din.available()>0) {
				s = din.readLine();
				comment = s.indexOf("/" + "*");
				c = s.indexOf("/" + "/");
				len = s.length();
				if (c>=0 && c<comment) comment = c;
				else if (comment<0) comment = len;
				i = s.indexOf("import");
				if (i>=0 && i<comment) {
					v.addElement(s);
					continue;
				} 
				i = s.indexOf("class");
				if (i>=0) {  // found a class; locate name
					i=i+5;
					while (i<len && Character.isSpace(s.charAt(i)))
					  i++;
					j = i;
					while (j<len && !Character.isSpace(s.charAt(j)) && s.charAt(j)!='{')
					  j++;
					// got name, now create output file
					fn = s.substring(i,j);
					if (mainfn.compareTo(fn+".java")==0) {
						// skip a class the same as the main file
						while(din.available()>0) {
							s = din.readLine();
							if (endOfClass(s)) 
							  break;
						}
					} else {
						System.out.println("Creating " + fn);
						writeClass(din,fn,s,v);
					}
				}
			}
		} catch(IOException e) {
			System.out.println("IOException: " + e.getMessage());
		}
	}

	// Returns true on success, false on failure
	public boolean run(String fn) {
		FileInputStream f;
		DataInputStream d;

		mainfn = fn;

		try {
			f = new FileInputStream(fn);
			d = new DataInputStream(f);
			if (d==null) return false;
			
			createSubfiles(d);
			
			d.close();
			f.close();
		} catch(FileNotFoundException e) {
			System.out.println("Can't find " + fn);
			return false;
		} catch(IOException e) {
			System.out.println("IOException with " + fn + ": " + e.getMessage());
			return false;
		}

		return true;
	}

	public static void main(String argv[]) {
		Explode e = new Explode();
		e.run(argv[0]);
	}
}
