/*
 Java Class Inspector
   Copyright (C) 1996 Clark VERBRUGGE.     Contact: clump@cs.mcgill.ca
   Copyright (C) 1996 McGill University. 
   Copyright (C) 1996 McCAT System Group.

   This program is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 1, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
   more details.

   You should have received a copy of the GNU General Public License along with
   this program; if not, write to the Free Software Foundation, Inc., 675
   Mass Ave, Cambridge, MA 02139, USA. */

import java.io.*;

abstract class cp_info {

	public static final byte CONSTANT_Utf8 = 1;
	public static final byte CONSTANT_Integer = 3;
	public static final byte CONSTANT_Float = 4;
	public static final byte CONSTANT_Long = 5;
	public static final byte CONSTANT_Double = 6;
	public static final byte CONSTANT_Class = 7;
	public static final byte CONSTANT_String = 8;
	public static final byte CONSTANT_Fieldref = 9;
	public static final byte CONSTANT_Methodref = 10;
	public static final byte CONSTANT_InterfaceMethodref = 11;
	public static final byte CONSTANT_NameAndType = 12;

	public byte tag;

	public abstract String toString(cp_info constant_pool[]);

	public abstract String typeName();

	public static long ints2long(int high,int low) {
		long h,l;
		h = high; l = low;
		return ((h<<32) | (l&0xffffffff));
	}

	public static String printBits(int i) {
		String s = "";
		int j,k;
		k = 1;
		for (j=0;j<32; j++) {
			if ((i&k)!=0) 
				s = "1" + s;
			else
				s = "0" + s;
			k = k<<1;
		}
		return s;
	}

	public static String printBits(long i) {
		String s = "";
		long j,k;
		k = 1;
		for (j=0;j<64; j++) {
			if ((i&k)!=0) 
				s = "1" + s;
			else
				s = "0" + s;
			k = k<<1;
		}
		return s;
	}
}
